# std::basic_string::rend, std::basic_string::crend

From cppreference.com
< cpp‎ | string‎ | basic string

reverse_iterator rend(); |  |
const_reverse_iterator rend() const; |  |
const_reverse_iterator crend() const; |  | (since C++11)

Returns a reverse iterator to the character following the last character of the reversed string. It corresponds to the character preceding the first character of the non-reversed string. This character acts as a placeholder, attempting to access it results in undefined behavior.

### Parameters

(none)

### Return value

reverse iterator to the character following the last character

### Exceptions

(none) | (until C++11)
`noexcept` specification: noexcept | (since C++11)

### Complexity

Constant

### Example

Run this code

    #include <algorithm>
    #include <iostream>
    #include <iterator>
    #include <string>

    int main()
    {
      std::string s("A man, a plan, a canal: Panama");
      {
        std::string c;
        std::copy(s.rbegin(), s.rend(), std::back_inserter(c));
        std::cout << c <<'\n'; // "amanaP :lanac a ,nalp a ,nam A"
      }

      {
        std::string c;
        std::copy(s.crbegin(), s.crend(), std::back_inserter(c));
        std::cout << c <<'\n'; // "amanaP :lanac a ,nalp a ,nam A"
      }
    }

Output:

    amanaP :lanac a ,nalp a ,nam A
    amanaP :lanac a ,nalp a ,nam A

### See also

rbegin crbegin (C++11) | returns a reverse iterator to the beginning (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/string/basic_string/rend&oldid=91482"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template